
#include "hspda.as"
#include "hspext.as"
#include "hspcmp.as"
;#include "cfgmod.as"
#packopt name "hsperun"
#packopt runtime "hsp2c.hrt"
#packopt hide 1

	;---------------------------------------------------
	;	Main sequence
	;---------------------------------------------------


*appstart
	;
	;	Boot sequence
	;
	apltitle="HSP runtime manager"
	version="0.6"

	sdim s1,1024
	sdim s2,1024
	sdim tool,1024
	sdim erstr,1024

	title apltitle+" ver"+version

	if hspstat&1=0 {
		tool=exedir+"\\" ; ̃fBNg
		chdir exedir	; EXEɂ́ANfBNgw
	} else {
		tool=curdir+"\\" ; ̃fBNg
	}

	;	define values
	;
	sdim fname,256
	sdim srcdir,256
	sdim typelist,256
	sdim hrtlist,16000
	lb_hrt=0
	cb_type=0
	sw_window=0
	opt_x=640
	opt_y=480

	typelist="Wst@C(EXE)\ntXN[st@C(EXE)\nXN[Z[o[(SCR)\n"

	;	hrtt@Čo
	;
	sdim dirs,32000
	sdim fl,256
	dirlist dirs,tool+"runtime\\*.hrt",1
	notesel dirs
	a=0
	notemax max
	repeat max
	  noteget fl,cnt
	  peek a,fl,0
	  if a=0 : continue
	  if a!='.' {
		hrtlist+=fl+"\n"
	  }
	loop

	sortnote hrtlist		; \[g
	peek hrtlist,hrtlist,2		; s΂

	;	main window setup
	;
	wx=320:wy=440
	screen 0,wx,wy
	gsel 0,1

*boot
	;	screen init
	;
	gsel 0
	gosub *getbgcolor
	color bg_r,bg_g,bg_b:boxf
	color 0,0,0
	objmode 1,1
	sysfont 17

	objsize 310,20
	pos 4,4:mes "packfilêfBNg"
	pos 4,20:input srcdir			;#0

	objsize 250,20
	pos 4,80:mes "gp郉^C"
	pos 4,96:listbox lb_hrt,160,hrtlist	;#1

	objsize 200,20
	pos 4,264:mes "t@C^Cg"
	pos 4,280:input fname			;#2
	objsize 198,20
	pos 6,304:combox cb_type,100,typelist

	objsize 240,20
	pos 8,330:chkbox "NɃCEChD\ɂ",sw_window
	chkbox "ÑfBNgړ𖳌ɂ",sw_orgpath
	objsize 50,20
	pos 8,378:mes "EChDTCY"
	pos 140,378:mes "X"
	pos 152,374:input opt_x
	pos 220,378:mes "Y"
	pos 232,374:input opt_y

	objsize 100,20
	pos wx-106,44:button "Q...",*refname1
	pos wx-106,wy-30:button "",*owari
	pos wx-212,wy-30:button "쐬",*main2

*main1
	stop

*cutlast
	;	s1Ō'\'菜
	;
	strlen a,s1
	if a=0 : return
	i=a-1
	peek a,s1,i
	if a='\\' : poke s1,i,0
	return

*refname1
	selfolder s1,""
	if stat=0 {
		fxshort s1,s1
		gosub *cutlast
		s1+="\\"
		s2=s1+"packfile"
		exist s2
		if strsize<0 {
			dialog "w肳ꂽfBNgpackfile܂"
			goto *main1
		}
		objprm 0,s1
	}
	goto *main1

*main2
	;	st@C쐬
	;
	er=0
	if fname="" : er+
	if srcdir="" : er+
	if lb_hrt<0 : er+
	if er : dialog "Kvȍڂw肳Ă܂",1 : goto *main1

	notesel hrtlist
	noteget s1,lb_hrt

	chdir srcdir
	pack_ini fname
	pack_rt tool+"runtime\\"+s1
	pack_opt opt_x, opt_y, sw_window + (sw_orgpath<<1)
	pack_make
	pack_exe cb_type
	if stat {
		sdim erbuf,32000
		hsc_getmes erbuf
		dialog erbuf
		goto *main1
	}

	delete fname+".dpm"
	dialog "st@C쐬܂"
	goto *main1
*owari
	end

*getbgcolor
	regkey 0,"Control Panel\\Colors",0 
	a="":getreg a,"ButtonFace"
	i=0
	repeat 3
	getstr wk,a,i,' '
	int wk:if wk : wk-
	if cnt=0 : bg_r=wk
	if cnt=1 : bg_g=wk
	if cnt=2 : bg_b=wk
	i+=strsize
	loop
	return
